/*
 * parachute.c
 *
 * Last modified: <2008/08/02 04:28:40 +0900> By SUMIDA
 */
#include <SDL.h>
#include "system.h"
#include "texture.h"
#include "ship.h"
#include "shot.h"
#include "enemy.h"
#include "effect.h"

void parachute_init(SHIP_INFO *info) {

	REPORT(format("info=%p, id=%d", info, info->id));
	info->sprite.options |= 15;
	info->sprite.dy = ToReal(1.5);
}

void parachute(SHIP_INFO *info, SHOT_MGR *shot_mgr, SHIP_INFO *ship) {

	SURFACE *surface_info = surface_get(info->sprite.surface_id);
	SURFACE *surface_ship = surface_get(ship->sprite.surface_id);

	info->sprite.dx = 0;

	if (info->sprite.y < ship->sprite.y) {
		Real x0 = info->sprite.x + (IntToReal(surface_info->frame_width) >> 1);
		Real x1 = ship->sprite.x + (IntToReal(surface_ship->frame_width) >> 1);

		if (x0 < x1)
			info->sprite.dx += ToReal(0.05);
		else if (x0 > x1)
			info->sprite.dx += ToReal(-0.05);
	}
}

void parachute_term(SHIP_INFO *info) {
	REPORT(format("info=%p", info));
}

