/*
 * ship.h
 *
 * Last modified: <2008/10/05 00:56:59 +0900> By SUMIDA
 */
#ifndef SHIP_H_INCLUDED
#define SHIP_H_INCLUDED

#include "sprite.h"

#define SHIP_DEF_LOST_WAIT  2

typedef enum SHIP_ID {

	SHIP_ID_ME = 0,
	SHIP_ID_ENEMY,
	SHIP_ID_ENEMY1 = SHIP_ID_ENEMY,
	SHIP_ID_ENEMY2,
	SHIP_ID_ENEMY3,
	SHIP_ID_ENEMY4,
	SHIP_ID_ENEMY5,
	SHIP_ID_ENEMY6,
	SHIP_ID_ENEMY7,
	SHIP_ID_ENEMY8,
	SHIP_ID_ENEMY9,
	SHIP_ID_AXE,
	SHIP_ID_PARACHUTE,
	SHIP_ID_BOX,
	SHIP_ID_SNOWFLAKE,
	SHIP_ID_FIRE,
	SHIP_ID_RING,
	SHIP_ID_BOSS2_HORN1,
	SHIP_ID_BOSS2_HORN2,
	SHIP_ID_BOSS2_HORN3,
	SHIP_ID_BOSS2_HORN4,
	SHIP_ID_BOSS,
	SHIP_ID_BOSS1 = SHIP_ID_BOSS,
	SHIP_ID_BOSS2,
	SHIP_ID_ITEM,
	ITEM_ID_POWERUP  = SHIP_ID_ITEM,
	ITEM_ID_SPEEDUP,
	ITEM_ID_MISSILE,
	ITEM_ID_3WAY,
	ITEM_ID_CHANGE,
	SHIP_ID_BONUS,
	BONUS_ID_STAR = SHIP_ID_BONUS,
	BONUS_ID_SSTAR,
	SHIP_ID_MAX
} SHIP_ID;

typedef enum SHIP_STAT {

	SHIP_STAT_LOST = 0,  /*      */
	SHIP_STAT_APPEAR,    /* o     */
	SHIP_STAT_NORMAL,    /* ʏ */
	SHIP_STAT_MOVE,      /* ړ     */
	SHIP_STAT_FIRE,      /* C     */
	SHIP_STAT_EXPLOSION, /*      */
	SHIP_STAT_MAX
} SHIP_STAT;

typedef enum SHIP_FLAG {

	SHIP_FLAG_DOWN     = 0x01000000,    /* e               */
	SHIP_FLAG_HEAVY    = 0x02000000,    /* dʑ             */
	SHIP_FLAG_NODAMAGE = 0x04000000,    /* m[_[W       */
	SHIP_FLAG_NOCLIP   = 0x08000000,    /* ʊOłȂ     */
	SHIP_FLAG_NOPOOL   = 0x10000000,    /* v[Ȃ     */
	SHIP_FLAG_ITEM     = 0x20000000,    /* ACe           */
	SHIP_FLAG_SYSTEM   = 0xff000000,    /* VXetO   */
	SHIP_FLAG_USERS = ~SHIP_FLAG_SYSTEM /* [UptO */
} SHIP_FLAG;

typedef struct SHIP_INFO {

	struct SHIP_INFO *prev;
	struct SHIP_INFO *next;
	int id;
	SPRITE sprite;
	SHIP_STAT stat;
	SHIP_FLAG flag;
	int count;
	int point;
	int strength;
	struct SHIP_INFO *parent;

} SHIP_INFO;

typedef struct SHIP_MGR {
	SHIP_INFO *active;
	SHIP_INFO *pool;
} SHIP_MGR;

extern void ship_init(SHIP_MGR *mgr, SHIP_INFO *infos, size_t number);

extern SHIP_INFO *ship_new(SHIP_MGR *mgr, SHIP_ID id);

extern SHIP_INFO *ship_child_new(SHIP_MGR *mgr, SHIP_ID id, SHIP_INFO *parent);

extern void ship_delete(SHIP_MGR *mgr, SHIP_INFO *info);

extern int ship_down(SHIP_INFO *info, int *strength, Real dx, Real dy);

extern void ship_action(SHIP_MGR *mgr, SHIP_MGR *enemy_mgr);

#endif
